<?php

/**
 * JTL Plugin
 * Copyright (C) 2011 - 2018 Andreas Petermann
 *
 * PHP version 5.6+
 *
 * @copyright css-umsetzung
 * @author Andreas Petermann <info@css-umsetzung.de>
 * @package css_shipping
 * @version 1.00
 *         
 */

namespace css_crossselling;


class Bootstrap extends \AbstractPlugin {
	
	public $oPlugin = null;
	
	public function boot(\EventDispatcher $dispatcher) {
		

		// bis 4.06.3 gibt es zu diesem Zeitpunkt noch kein smarty daher kann der Service hier nicht angeboten werden.
		if(version_compare(JTL_VERSION, 405, '<=') || (JTL_VERSION==406 && (int) JTL_MINOR_VERSION<3)) return;
		
		$smarty = \Shop::Smarty();
		if($smarty->getTemplateVars('admin_js') !== null) {
			$oPlugin = $this->oPlugin = \Plugin::getPluginById(__NAMESPACE__);
			$smarty->assign("cssBootstrapPlugin",$oPlugin);
			if(!\Shop::has("cssUseBootstrapJS")) {
				$smarty->assign('admin_js',$smarty->getTemplateVars('admin_js').'<script src="'.$oPlugin->cAdminmenuPfadURL.'js/bootstrap.js"></script>');
				\Shop::set("cssUseBootstrapJS",true);
			}
			$smarty->assign('admin_js',$smarty->getTemplateVars('admin_js').$smarty->fetch($oPlugin->cAdminmenuPfad.'js/bootstrap_plugin.tpl'));

			if(isset($_GET['pluginverwaltung_uebersicht']) &&  isset($_GET['kPlugin']) && $_GET['kPlugin'] == $oPlugin->kPlugin) {
				$smarty->assign('admin_js',$smarty->getTemplateVars('admin_js').$smarty->fetch($oPlugin->cAdminmenuPfad.'js/language_plugin.tpl'));
			}
			
		}

		parent::boot($dispatcher);
		
	}
	
	public function installed() {
		self::installTables ();
		parent::installed (); // TODO: Change the autogenerated stub
	}
	
	public function uninstalled() {
		if(isset($_POST['css-delete-tables-from-'.__NAMESPACE__]) || version_compare(JTL_VERSION, 405, '<=')) {
			self::deletePluginTables(__NAMESPACE__.'_');
		}
		parent::uninstalled (); // TODO: Change the autogenerated stub
	}
	
	public function enabled() {
		parent::enabled (); // TODO: Change the autogenerated stub
	}
	
	public function disabled() {
		
		parent::disabled (); // TODO: Change the autogenerated stub
	}

	public function deletePluginTables($tables) {
		$db = \Shop::DB();
		if(($tables = self::getPluginTables($tables))) {
			$query = "DROP TABLE IF EXISTS ".join(", ",$tables);
			$db->query($query,3);
		}
	}
	
	public function getPluginTables($table) {
		$db = \Shop::DB();
		$table_schema = DB_NAME;
		$table_name = $table;
		$sql = "SELECT table_name FROM information_schema.tables WHERE table_schema = '$table_schema' AND table_name LIKE '".$table_name."%'";
		$obj = $db->query($sql,2);
		if($obj !== null && $obj !== false && count($obj)) {
			$data = array();
			foreach($obj as $oTable) {
				$data[] = $oTable->table_name;
			}
			return $data;
		}
		return false;
	}
	
	public static function testIfTableExist($table='') {
		$db = \Shop::DB();
		$table_schema = DB_NAME;
		$table_name = $table;
		$sql = "SELECT COUNT(*) AS count FROM information_schema.tables WHERE table_schema = '$table_schema' AND table_name = '$table_name'";
		$obj = $db->query($sql,1);
		return $obj->count;
	}
	
	public function installTables() {
		$db = \Shop::DB ();
		if (! self::testIfTableExist ( __NAMESPACE__ . '_konfig' )) {
			$sqlFile = file_get_contents ( dirname ( __FILE__ ) . '/sql/install.sql' );
			$sqlquerys = explode ( ";", $sqlFile );
			foreach ( $sqlquerys as $query ) {
				if (! empty ( trim ( $query ) )) {
					$db->query ( $query, 3 );
				}
			}
		}
	}
}
